function y = demodulate(filt_in,cycle_len,cal_shift,IOSR)

demod_signal = [zeros(1,cycle_len*floor(length(filt_in)/cycle_len))];
int_signal = [zeros(1,floor(length(filt_in)/(IOSR)-1))];
demod_cycle = [ones(1,ceil(cycle_len/2)) -1*ones(1,floor(cycle_len/2))];
i=1;
for n=cal_shift:cycle_len:cycle_len*(floor(length(filt_in)/cycle_len)-1)
    demod_signal(i:i+cycle_len-1)=filt_in(n:n+cycle_len-1).*demod_cycle;
    i=i+cycle_len;
end


i=1;
for n=1:IOSR:IOSR*floor(length(filt_in)/(IOSR)-1)
    int_signal(i)=sum(demod_signal(n:n+IOSR-1));
    i=i+1;
end
y = int_signal;
    