function y = sincfilt(order,OSR,input)

filt_out = [zeros(1, length(input))];   %initialize this variable
NUM_FO = [1 zeros(1,OSR-1) -1];         %first order numerator
DEN_FO = [1 -1];                        %first order denominator
switch order
    case 1                  %sinc1
    NUM = NUM_FO;
    DEN = DEN_FO;
    TF = tf(NUM,DEN,'Variable','q');     
    case 2                  %sinc2
    NUM = conv(NUM_FO,NUM_FO);
    DEN = conv(DEN_FO,DEN_FO);
    TF = tf(NUM,DEN,'Variable','q');       
    case 3                  %sinc3
    NUM = conv(NUM_FO,conv(NUM_FO,NUM_FO));
    DEN = conv(DEN_FO,conv(DEN_FO,DEN_FO));
    TF = tf(NUM,DEN,'Variable','q');     
    case 4                  %sincfast
    NUM = conv(NUM_FO,NUM_FO);
    NUM = conv(NUM,[1 zeros(1,2*OSR-1) 1]);   
    DEN = conv(DEN_FO,DEN_FO);
    TF = tf(NUM,DEN,'Variable','q');        
    otherwise
    disp('Invalid value for filter order');
end
%[H,w]=freqz(NUM,DEN);
%zplane(NUM,DEN);
filt_out=filter(NUM,DEN,input); %filter input data
y=downsample(filt_out,OSR);     %decimate filtered data