function y = calres(filt_in,pat_length)

% use the middle of the array to assure filters are in steady state
center_mod = filt_in(floor(0.25*length(filt_in)):floor(0.75*length(filt_in)));
% search for negative to positive transtion when signal is at a max
% amplitude
[M,I]=max(center_mod);
for n=I-2*pat_length:1:I
    if((filt_in(n-1)<0)&(filt_in(n)>0))
        y = mod(n,pat_length);
        return;
    end
end
error('Calibration function failed.');
y = 0;
